



                    #property      copyright      "Keit Thomas Largo"
                    #property      link       "CockeyedCowboy@gmail.com"

                    #property      indicator_chart_window
                    #property      indicator_buffers 0




            #import "user32.dll"
               int   PostMessageA( int hWnd, int Msg, int wParam, int lParam );

            #import




            #define   OneHourChart             35400
            #define   ThirtyMinuteChart        33140
            #define   FiveMinuteChart          33138




            extern bool
                TimeForPhotos     =   False,
                AskForTick        =   True;





            bool
                RequestPlaced     =    False;

            string
                TickRequest       =   "";

            datetime
                TakePhoto         =   0;



      
void
    init() {

        TakePhoto  =  TimeLocal() + 1;

        if( ! GlobalVariableCheck( "PhotoTest" ))
            GlobalVariableSet( "PhotoTest", 0 );

    return;

} // End Routine Procedure, init:




void
    start() {

        if( AskForTick && ! RequestPlaced )
            RequestTick( RequestPlaced, TickRequest );

        if( TimeForPhotos )
            TakeScreenShots( TakePhoto );

    return;

} // End Routine Procedure, start:





void
    deinit() {

        if( UninitializeReason() != REASON_CHARTCHANGE ) {
            GlobalVariableDel( TickRequest );
            GlobalVariableDel( "PhotoTest" );

        } // End If, UninitializeReason:

    return;

} // End Routine Procedure, deinit:




void
    TakeScreenShots( datetime PhotoTime ) {
        bool       Finished        =   False;
	    int        CurrentScale    =   Period();
	    int        ChangeScaleTo   =   0;
        int        NewChart        =   0;
        int        ChartHandle     =   WindowHandle( Symbol(), CurrentScale );
        string     FileName        =   "Sample" + Symbol() + DoubleToStr( CurrentScale, 0 ) + ".gif";

            if( GlobalVariableGet( "PhotoTest" ) == 0 && PhotoTime < TimeLocal()) {
                WindowScreenShot( FileName, 640, 480 );

                switch( CurrentScale ) {
                    case PERIOD_H1:
                        ChangeScaleTo  =  ThirtyMinuteChart;
                        break;

                    case PERIOD_M30:
                        ChangeScaleTo  =  FiveMinuteChart;
                        break;

                    case PERIOD_M5:
                        ChangeScaleTo  =  OneHourChart;
                        GlobalVariableSet(  "PhotoTest" , 1 );
                        break;

                } // End Switch Case, CurrentScale:

                PostMessageA( ChartHandle, 0x0111, ChangeScaleTo, 0 );

            } // End If, GlobalVariableGet:

	return;

} // End Routine Procedure, TakeScreenShots:




void
    RequestTick( bool& RequestPlaced, string& ProgramGlobal ) {
        int      CID       =   WindowHandle( Symbol(), Period());
        int      Length    =   StringLen( DoubleToStr( CID, 0 )) - 3;
        string   Run       =   StringSubstr( DoubleToStr( CID, 0 ), Length ) + " ";
        string   Request   =   Run + "XYZ Tick Request ";

            GlobalVariableSet( Request, CID );

            ProgramGlobal  =  Request;
            RequestPlaced  =  True;

    return;

} // End Routine Procedure, $_RequestTick:




