



#define @_End ""// MetaQuote [ MQ 4 ] 
#define                               IDENTIFICATION~DIVISION                                    10
// v1 




                    #define   $_ProgramName         "Send Time Tick"
                    #define   $_ProgramSymbol       "STT"
                    #define   $_FileName            "Send Time Tick.mq4"
                    #define   @_SystemName          "None"
                    #define   $_Author              "Keit Thomas Largo"
                    #define   $_eMail               "CockeyedCowboy@gmail,coom"
                    #define   $_CompanyName         "WinSoft Technology  "
                    #define   $_LicenseTo           "Open Source"
                    #define   $_ModuleType          "Script File"
                    #define   $_DateWriten          "03.30.2012"
                    #define   $_VersionNumber       "1.10 b01 pb"
                    #define   $_LastUpDate          "03.30.2012"
                    #define   $_ProgramLanguage     "MetaQuote  MQL v4.00, b409"
                    #define   $_Documentation       "see {Documentation Division}"
                    #define   $_CopyRight           "CopyRight    2012"




//
string @_CopyRightWarning[]={// 20x65 




                "  The \' Send Time Ticks \' indicator, its supportive file, and    ",
                "  any created data files if any, are CopyRighted material of Keit  ",
                "  Thomas Largo and WinSoft Technology.  You must treat this soft-  ",
                "  ware, like any other copyrighted material. The Author has freely ",
                "  released this  version of the  software to the members of the    ",
                "  \'Forex TDS \' Forum.  As an aid in their private and presonal   ",
                "  trading operation. You are NOT permitted to rent, sell, resell,  ",
                "  or otherwise distribute this software in any commercial and /or  ",
                "  profitable endeavors, with out the written  permission from the  ",
                "            author. No other rights are granded.                   ",

			    "                ~~~ Keit Thomas Largo ~~~                          ",




@_End};//
string @_VersionComments[]={// 10x65 




                 "      WARNING: THIS IS AN BETA RELEASE,  EXPECT SOME BUGS       ",

                 "   WinSoft Technology Inc.,  EXPRESSLY DISCLAIMS ANY WARRANTY   ",
                 "   for this  SOFTWARE.  The  SOFTWARE  along with any related   ",
                 "   documentation is provided   AS IS   without any waranties,   ",
                 "   either express or implied. Including, the implied warranty   ",
                 "   of merchantability or fitness for any  particular purpose.   ",
                 "   The entire risks  arising out of  usage or performance  of   ",
                 "   this SOFTWARE, re-mains with the user.  WinSoft Technology   ",
                 "   Inc. assumes  NO LIABILITY FOR DAMAGES OR LOSS  whatsoever   ",
                 "   arising from the use or inability of use of this SOFTWARE.   ",




@_End};//
#define                                COMPILER~DIRECTIVES                                       20
//  FILE LINKAGE: 




                    #property      copyright      "Keit Thomas Largo"
                    #property      link           "CockeyedCowboy@gmail,coom"
                    #property      show_inputs


                    #import "user32.dll"
                        int  RegisterWindowMessageA( string SendNote );
                        int  PostMessageA( int Handle, int Msg, int wParam, int lParam );

                    #import




//
#define                                ENVIRONMENT~DIVISION                                      30
//  DEFINED CONSTANT: 




//
//  EXTERN PARAMETER: 




        extern
            bool
                @_RefreshData    =   False,   // Switch to refresh data between ticks.
                @_FillRequests   =   False;   // Switch to send ticks to another window.


        extern
            int
                @_SleepTime      =     500,   // Time period between ticks
                @_Multiples      =       1;   // The number of times a tick is thrown.




//
//  DEFAULT ATTRIBUTES: 




//
//  GLOBAL SCOPE VARIABLES: 




//
//  GLOBAL SCOPE ARRAYS: 


//
#define                               CONFIGURATION~DIVISION                                     40
void init(){//




                @_SleepTime  =  MathMax( 500, @_SleepTime );




return;}//
#define                                   CODING~DIVISION                                        50
void start(){//




            while( ! IsStopped() ) {
                if( IsDllsAllowed()) {
                    $_ThrowNewTick( @_SleepTime, @_Multiples, @_RefreshData, @_FillRequests );

                } else {
                    PlaySound( "DLL Libraries Required.wav" );
                    break;

                } // End If, IsDllsAllowed:
            } // End While Loop, IsStopped:




return;}//
#define                                   OUTPUT~DIVISION                                        60
void OutPut(){//




return;}//
#define                                TERMINATION~DIVISION                                      70
void deinit(){//




return;}//
#define                           PROCEDURAL~DEFINITION~DIVISION                                 80
//  OBJECT PROPERTIES: 




/*===============================================================================================|\
||                                                                                               ||
||  $_ThrowNewTick Routine Procedure            v3.00            Date 01.23.2010           KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     This creates false ticks to run programs on a time base instead of tick wise.   ||
||               It has a parameter to refresh the price data after the the tick was generated   ||
||               to give your EA or script fresh data to work with.                              ||
||                                                                                               ||
||  Parameters:  Control  --- This parameter contains the window handle.                         ||
||               TickOff  --- This is the number of millie seconds to wait between ticks.        ||
||               TickLoop --- The number of ticks to throw before the EA or script runs.         ||
||               Refresh  --- Refreshes the data so the EA or script can work with fresh price   ||
||                               data.                                                           ||
||                                                                                               ||
||  Note:        Added the Refresh parameter as the first version was not letting the script     ||
||               see new price data. If one is only generating ticks to run indicator on the     ||
||               MT chart then this can be fales.                                                ||
||                                                                                               ||
||               version 3 has the ability to throw ticks to another window on request if a      ||
||               window ask for ticks.                                                           ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    $_ThrowNewTick( int TickOff, int TickLoop, bool Refresh, bool CheckRequests ) {
        int      Index       =   0;
        int      Request     =   0;
        int      Error       =   GetLastError();
        int      CID         =   WindowHandle( Symbol(), Period());
        int      Message     =   RegisterWindowMessageA( "MetaTrader4_Internal_Message" );
        int      RequistID   =   0;
        string   Global      =   "";
        string   Test        =   "";

            for( Index = 1; Index <= TickLoop; Index ++ ) {
                Sleep ( TickOff );
                PostMessageA( CID, Message, 2, 1 );

                if( CheckRequests ) {
                    for( Request = GlobalVariablesTotal() - 1; Request >= 0; Request -- ) {
                        Global   =  GlobalVariableName( Request );
                        Test     =  StringSubstr( Global, 8, 12 );

                        if( Test == "Tick Request" ) {
                            RequistID  =  GlobalVariableGet( Global );
                            PostMessageA( RequistID, Message, 2, 1 );

                        } // End If, Test:
                    } // End For Loop, Request:
                } // End If, CheckRequests:
            } // End For Loop, Loop:

            if( Refresh )   {   RefreshRates();   }

   return;

} // End Routine Procedure, $_ThrowNewTick:




//
//                                     DOCUMENTATION~DIVISION                                    90
/*  PURPOSE AND SCOPE: 




    This script will generate timed ticks to the chart window it is attached to. It will do
    nothing else but throw ticks. It is intended to run the indicators that are on the chart
    of which this tick generator is attched to, on a timed bases instead of a tick base.


    There are 2 include files, with this code but they are not needed to run the main program
    code (Send Time Tick.mq4). The include files were supplied to give you different configuration
    possibilities in the usage of this code.


    The basic code was created by a person with the nick, '7bits'. from which I have made a bug
    fix and have added several additional feathers.





  FUNCTION OF PROGRAM: 




    DEFAULT PARAMETERS:

    There are several external parameters in this script file and they can be changed when you
    add this script to a chart window. These parameters;


        @_RefreshData:  Default is set to  False.
            This parameter is not needed to run indicator on the chart, but if you are including
            this code in to another script or EA and that program can place or manage Positions,
            this then must be set to true. If not your script or EA will not ever get to see
            new data. This is due to MT not updating the data that a script or ea uses during it
            run. Data in a script or EA is only updated when it stops its run. Because of the
            need of a loop with in this script new data will never be seen. If your just running
            this as a means to make indicator run in real time then leave this off (False).


        @_FillRequests:  Default is set to False.
            This parameter adds the ability of this tick generater to feed ticks to other windows
            that it is not attached too. In its normal state this script will only generate ticks
            to the window it is attached to. But if this parameter is set to True, it has the
            ability to send ticks to other windows. To do this the other window must ask for ticks
            to be sent it. If no request are made for ticks from other window this this feather
            will server not purpose and should be left off (False).


        @_SleepTime: Default is set to 500.
            This is the amount of time that the script will sleep between ticks. This is in MS.
            The default is 500 there for it will throw a new tick each one half second, 2 tick
            per second. If you want to throw ticks each second then change this parameter to
            1000. or 1000 for each second you want the script to sleep. One note here is that
            the indicators on the chart will also run if there is a new incoming tick from the
            server, as well. With this in mine you are going to be running the indicator code
            more offen then this sleep time but the longest time it will stay idle is the 
            amount of this parameter. If this code is built in to an existing EA or script then
            the other code within that script or EA will delay the next tick in the amount of
            time equal to the time it took to run the other code. So we will have some variance
            in the actural time that the tick are thrown. The lowest time that is permitted is
            500 MS if you try to imput a smaller amount the program will use the default value.


        @_Multiples: The Default here is set to 1.
            This feather was added for people that do coding. It is intended to have the tick
            generator throw ticks to get all indicator up in running before the script enters
            into the loop. I have wrote several indicator in the past that needed more then one
            tick to get them up and running due to the several different functions that had to
            be done before it could run. It is also good if your programing on the week ends
            were not ticks are avaible to get indicators going. Anyone that does not code or
            lacks the knowledge to code should leave this set to one.




    MAIN PROGRAM FILE.

        SCRIPT FILE:   'Send Time Tick.mq4"

        To operate its really simple just drop this main script on any window. That is any
        Currency window that has no other script or EA running on it. As MT only permits one EA
        or Script to run on any window. If you want to generate ticks on a window that already
        has a script or EA, then all you have to do is open up another window (of any pair) and
        attached this main script to that window WITH the external parameter '@_FillRequests' set
        to TRUE. Then in the other script your using add the include file 'Request Time Ticks.mqh'
        to it as explained below. This include file will make your EA, script or indcators request
        ticks from another tick generator that is attached on the current MT platform. It will not
        get ticks from another copy of MT, how ever. IF that tick generator is set to 'Fill Requests'
        you will start receiving ticks. You should have only one code from a chart window requesting
        ticks. If more then one is request ticks it will server no purpose. Also you should have
        only one tick generator set to fill request for ticks on any copy of the MT flatform. You can
        have multiple tick generator running on any given MT platform but make only one respond to
        request. If two generators are filling requests then you code will be receiveing ticks from
        both of them, causeing your code to continually run.




    USING THE INDICATOR FILE:

        INDICATOR FILE:  "Time Requested Ticks.mq4"

            This is a companion file to be used along side the tick generator. If you have a
            system that uses a script or EA then you connot attach another script to that
            chart window. Therefore, if you want to run your system in real time just attach
            this indicator to you system and the tick generator to a another window. It can
            be added to any window that doesnot have a script or EA on it. It can even be a
            window that is minimized and not visible. This indicator does nothing but open
            and maintains a link between your system (window) and any tick generator that is
            running that copy of the MT platform. 




    USING THE INCLUDE FILES:

        THE INCLUDE FILE:  "Request Time Ticks.mqh"

            This files main purpose is to set up the request format for receiving ticks from 
            a generator attached to another chart on the same MT plateform. If no generator
            is found or if that generator is not receiving request for ticks then this code
            will have not effect on your program.

            There are only 3 lines of code that need to be added to your code to make it
            capable to request ticks. These are, along with where the lines need to be placed:



            #include <Request Time Ticks.mqh>

            This line will introduce all of the needed code into your code. It must be placed
            at the start of the your code in the global area. The best place would be right
            after the #property tags.



            if( ! @_PlaceRequest )   {   $_RequestTick( @_PlaceRequest, @_GlobalName );   }

            This line has to be pressent in the 'start()' function of your code. Here it would be
            best to have it as one of the first actionable line of code in the start() function.
            It must be in the main flow of the program. That is, it should not be inside any
            loops or re-directional coding. This line of code will set up the request once. There
            after, the code will no longer be visited by your code, as we only need to set the
            request up once one time and it will stay in effect for the complete run. 



            $_RemoveTickRequest( @_GlobalName );

            This line needs to go in the 'deint()' function in the main flow of the program.
            Not inside any loops or re directional code blocks. Its purpose is to remove
            the request for time ticks when the program ends.

            Copies of these lines are also supplied in the include file at the end in that
            codes documentation divion so you can just copy and past them in your code.




        THE INCLUDE FILE:  "Add Tick Generator.mqh".

            This files main purpose is to add a tick generator to an existing code. The code
            has to be either a Script or EA. Do not apply this include file to an Indicator
            file. Also the Script or EA must be constructed within a loop. All of the external
            parameters that that are in the main code will be attached to your program code.
            A all mean the same and operate as in the main code.

            There are only 2 lines of code that need to be added to your code to make it
            capable of generating its own ticks. These are, along with where the lines need
            to be placed:



            #include <Add Tick Generator.mqh>

            This line will introduce all of the needed code into your code. It must be placed
            at the start of the your code in the global area. The best place would be right
            after the #property tags.



            If( ! GeneratorTicks( @_SleepTime, @_Multiples, @_RefreshData, @_FillRequests )) return;

            This line has to be pressent in the 'start()' function of your code. It has to be placed
            within a loop structure of your code and one of the first actionable line of code with
            in that structure. It must be in the main flow of the program. That is, it should not be
            inside of any re-directional coding. This line of code will set up the tick generator
            within your code.




    ONE LAST COMMENT:

        You do not need to re-write your EA or create a special Looped script to have the effects
        of this tick generator. all you need to use is the script 'Send Time Tick' applied to the
        sepperate chart window and then minimize tha window to get it out of the way. Remember to
        active the scritp to receive incoming requests for ticks.

        Then just add the indicator 'Time Requested Ticks' to any given window and the tick 
        generator that you installed on the window that you've minimized will make all the
        indicator and your EA run time wise on that window also. So if you have more then one
        window open while you trade you will need to add this 'Time Requested Ticks' indicator
        on each window you have open. I beleive that this will be the easiest way for non coders
        to use this code.





  FILES DISCRIPTIONS: 


        The following files are needed and must be located in the correct directries for
        this program to run.

            The main programs files are to be installed in to the 'MT >> expert >> script'
            directory. These are the main files to operate the program. They are needed if
            one wants to run the program as a stand alone program, but are not needed if
            you are to use the include method and add the code to an exsiting program.
            The .ex4 file was supplied for those that are not able to compile .mq4 code.

                'Send Time Tick.mq4'  and/or
                'Send Time Tick.ex4'




            This is an indicator files and are to be installed in the 'MT >> expert >> script'
            directory. These files do nothing except create a link between the tick generator
            and other windows. That is you can install this indicator on one window to receive
            ticks from a tick generator on another window. So long as the tick generator is
            set to answer request. The .ex4 file is supplied for those that are not able to
            compile code.

                'Time Requested Ticks.mq4'  and/or
                'Time Requested Ticks.ex4'




            Thesee include files may or may not be needed if your running this indicator with
            the use of the main program file. The include files gives one the ability to add
            this code into an existing, coded indicator, EA, or script file. It make a
            differeance which type of file one adds these include files to so be sure toread
            the direction above on how to use them. These files must be located in the
            'MT >> expert >> include' directory, if useing one of the include method of
            installation and or running this program.

                'Request Time Ticks.mqh'
                'Add Tick Generator.mqh'




            All of the following sound wave files must be located in the 'MT >> sound'
            directory. These are the sound waves call by the program on given events.
            All of these files are required for the use of the main program file and
            for the include format if used.

                'DLL Libraries Required.wav'  SoundWave to informs user to turn on dll files.





  TESTING AND DEBUGING: 





  VERSION UPDATES: 




        Current Revisions:
            Version 1.10 b01 pb     03.30.2011
                *   Added the ability to send ticks to other windows if they have requested
                    ticks to be sent.

                *   Added the Refresh parameter to refresh the Price data with in the running
                    script or EA.

                *   Added the ability of sending ticks to other windows that the tick generator
                    is not attached to.

                *   Added the indicator file 'Time Requested Ticks.mq4'


        Future Enhancement:
                - 	





  SCRIPT NOTES: 





  CODE STORAGE: 




/*===============================================================================================|\
||                                                                                               ||
||  Public Private Function Routine GUI Procedure Property    v1.00    Date 00.00.2012     KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     None.                                                                           ||
||                                                                                               ||
||  Parameters:  None.                                                                           ||
||                                                                                               ||
||  Note:        None.                                                                           ||
||                                                                                               ||
||  Example:     None.                                                                           ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/




//*/
#define                                 END~PROGRAM~SCRIPT~[mq4]                                 00
// [ v1.rev.01-01-2012] 




